Index: oln/core/abstract/niter.hh
===================================================================
--- oln/core/abstract/niter.hh	(revision 130)
+++ oln/core/abstract/niter.hh	(working copy)
@@ -34,9 +34,10 @@
 # include <mlc/types.hh>
 # include <mlc/contract.hh>
 
+# include <oln/core/typedefs.hh>
+
 # include <oln/core/gen/image_with_nbh.hh>
 # include <oln/core/abstract/point.hh>
-# include <oln/core/properties.hh>
 # include <oln/core/abstract/image.hh>
 # include <oln/core/abstract/neighborhood.hh>
 # include <oln/core/abstract/image_neighbness.hh>
@@ -56,60 +57,60 @@
   for(p.start(); p.is_valid(); p.next()) \
   for(n.center_at(p), n.start(); n.is_valid(); n.next())
 
+
+
+# define oln_nit_type_of(NiterType, Alias) \
+mlc_type_of(oln, oln::category::niter, NiterType, Alias)
+
+
+
 namespace oln {
 
-  // fwd decl
-  namespace abstract {
-    template <typename E> struct niter;
+
+  namespace category
+  {
+    struct niter;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::niter<E> > { typedef category::niter ret; };
 
+  template <>
+  struct set_default_props < category::niter >
+  {
+    typedef mlc::undefined_type point_type;
+    typedef mlc::undefined_type neighb_type;
+  };
 
-  /// properties of any type in category::niter
 
-  template <typename type>
-  struct props_of < category::niter, type >
+  template <typename N>
+  struct get_props < category::niter, N >
   {
-    typedef mlc::true_type user_defined_;
+    typedef oln_nit_type_of(N, point) point_type;
+    typedef oln_nit_type_of(N, neighb) neighb_type;
 
-    mlc_decl_prop(category::niter, point_type);
-    mlc_decl_prop(category::niter, dpoint_type);
-    mlc_decl_prop(category::niter, neighb_type);
-    mlc_decl_prop(category::niter, image_type);
-
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of( category::niter, "
-	   << typeid(type).name() << ") = {"
-	   << "  neighb_type = " << typeid(neighb_type).name()
-	   << "  image_type = " << typeid(image_type).name()
-	   << "  point_type = " << typeid(point_type).name() << "  }" << std::endl;
+      ostr << "props_of( oln::category::niter, " << mlc_to_string(N) << " ) =" << std::endl
+	   << "\t point_type  = " << mlc_to_string(point_type) << std::endl
+	   << "\t neighb_type = " << mlc_to_string(neighb_type) << std::endl
+	   << std::endl;
     }
-
   };
 
-  mlc_register_prop(category::niter, neighb_type);
-  mlc_register_prop(category::niter, point_type);
-  mlc_register_prop(category::niter, dpoint_type);
-  mlc_register_prop(category::niter, image_type);
 
 
   namespace abstract {
 
     template <typename E>
-    struct niter : public mlc::any__best_speed<E>
+    struct niter : public mlc::any<E>
     {
 
       /// typedefs
 
       typedef niter<E> self_type;
 
-      typedef oln_type_of(E, point) point_type;
-      typedef oln_type_of(E, neighb) neighb_type;
-      typedef oln_type_of(E, image) image_type;
+      typedef oln_nit_type_of(E, point) point_type;
+      typedef oln_nit_type_of(E, neighb) neighb_type;
+      typedef oln_nit_type_of(E, image) image_type;
 
       void start()
       {
@@ -118,17 +119,19 @@
 
       void next()
       {
+	precondition(this->is_valid());
 	this->exact().impl_next();
       }
 
       operator point_type() const
       {
+	precondition(this->is_valid());
 	return this->exact().impl_cast_point();
       }
 
-      void center_at(const point_type& pt)
+      void center_at(const point_type& p)
       {
-	this->exact().impl_center_at(pt);
+	this->exact().impl_center_at(p);
       }
 
       bool is_valid() const
@@ -138,22 +141,24 @@
 
       void invalidate()
       {
-	return this->exact().impl_invalidate();
+	this->exact().impl_invalidate();
       }
 
     protected:
 
-      template <typename T>
-      niter(const abstract::image_with_nbh<T>& ima) :
-	p_(), nbh_(ima.nbh_get())
+      template <typename I>
+      niter(const abstract::image_with_nbh<I>& ima) :
+	nbh_(ima.nbh_get())
       {
       }
 
+      const neighb_type& nbh_;
       point_type p_;
-      const neighb_type& nbh_;
     };
-  }
-}
 
+  } // end of namespace oln::abstract
 
+} // end of namespace oln
+
+
 #endif // ! OLENA_CORE_ABSTRACT_NITER_HH
Index: oln/core/abstract/image.hh
===================================================================
--- oln/core/abstract/image.hh	(revision 130)
+++ oln/core/abstract/image.hh	(working copy)
@@ -28,99 +28,123 @@
 #ifndef OLENA_CORE_ABSTRACT_IMAGE_HH
 # define OLENA_CORE_ABSTRACT_IMAGE_HH
 
-# include <mlc/types.hh>
+# include <oln/core/typedefs.hh>
 
-# include <oln/core/abstract/internal/image_impl.hh>
-# include <oln/core/properties.hh>
-# include <oln/core/value_box.hh>
 
+# define oln_type_of_(ImageType, Alias) \
+mlc_type_of_(oln, oln::category::image, ImageType, Alias)
 
-/*! \namespace oln
-** \brief oln namespace.
-*/
+# define oln_type_of(ImageType, Alias) \
+mlc_type_of(oln, oln::category::image, ImageType, Alias)
+
+
+
 namespace oln {
 
 
-  // fwd decl
-  namespace abstract {
-    template <typename E> struct image;
-    template <typename E> struct readonly_image;
-    template <typename E> struct image_without_nbh;
+  // fwd decls
+  namespace abstract
+  {
+    template <typename I> class image_without_nbh;
+    template <typename I> class readonly_image;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::image<E> > { typedef category::image ret; };
 
+  namespace category
+  {
+    struct image;
+  }
 
 
-  /// properties of any type in category::image
+  /// Default properties of any image type.
 
-  template <typename type>
-  struct props_of <category::image, type>
+  template <>
+  struct set_default_props < category::image >
   {
-    typedef mlc::true_type user_defined_;
-    
-    mlc_decl_prop(category::image, concrete_type);
-    mlc_decl_prop(category::image, value_type);
-    mlc_decl_prop(category::image, point_type);
-    mlc_decl_prop(category::image, size_type);
-    mlc_decl_prop(category::image, piter_type);
-    mlc_decl_prop(category::image, fwd_piter_type);
-    mlc_decl_prop(category::image, bkd_piter_type);
-    mlc_decl_prop_with_default(category::image, value_storage_type, mlc::no_type);
-    mlc_decl_prop_with_default(category::image, storage_type, mlc::no_type);
-    mlc_decl_prop_with_default(category::image, delegated_type, mlc::no_type);
-    mlc_decl_prop_with_default(category::image, neighb_type, mlc::no_type);
+    typedef mlc::undefined_type concrete_type;
+    typedef mlc::undefined_type value_type;
+    typedef mlc::undefined_type point_type;
+    typedef mlc::undefined_type size_type;
+    typedef mlc::undefined_type piter_type;
+    typedef mlc::undefined_type fwd_piter_type;
+    typedef mlc::undefined_type bkd_piter_type;
 
+    typedef mlc::no_type value_storage_type;
+    typedef mlc::no_type storage_type;
+    typedef mlc::no_type delegated_type;
+    typedef mlc::no_type neighb_type;
 
-    mlc_decl_prop_with_default(category::image, image_neighbness_type, is_a<abstract::image_without_nbh>);
-    mlc_decl_prop_with_default(category::image, image_constness_type, is_a<abstract::readonly_image>);
-    mlc_decl_prop(category::image, image_dimension_type);
 
+    typedef is_a<abstract::image_without_nbh> image_neighbness_type;
+    typedef is_a<abstract::readonly_image> image_constness_type;
+    typedef mlc::undefined_type image_dimension_type;
+
     //...
 
+  };
+
+
+  /// Retrieval of any image type properties (FIXME: say 'packing').
+
+  template <typename I>
+  struct get_props < category::image, I >
+  {
+    typedef oln_type_of(I, concrete) concrete_type;
+    typedef oln_type_of(I, value) value_type;
+    typedef oln_type_of(I, point) point_type;
+    typedef oln_type_of(I, size) size_type;
+
+    typedef oln_type_of(I, piter) piter_type;
+    typedef oln_type_of(I, fwd_piter) fwd_piter_type;
+    typedef oln_type_of(I, bkd_piter) bkd_piter_type;
+
+    typedef oln_type_of(I, value_storage) value_storage_type;
+    typedef oln_type_of(I, storage) storage_type;
+    typedef oln_type_of(I, delegated) delegated_type;
+    typedef oln_type_of(I, neighb) neighb_type;
+
+
+    typedef oln_type_of(I, image_neighbness) image_neighbness_type;
+    typedef oln_type_of(I, image_constness) image_constness_type;
+    typedef oln_type_of(I, image_dimension) image_dimension_type;
+
+    //...
+
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of(" // FIXME: << typeid(oln::category::image).name()
-	   << ", " << typeid(type).name() << ") = {"
-	   << "  concrete_type = " << typeid(concrete_type).name()
-	   << "  value_type = " << typeid(value_type).name()
-	   << "  neighb_type = " << typeid(neighb_type).name()
-	   << "  point_type = " << typeid(point_type).name()
-	   << "  size_type = " << typeid(size_type).name()
-	   << "  fwd_piter_type = " << typeid(fwd_piter_type).name()
-	   << "  value_storage_type = " << typeid(value_storage_type).name()
-	   << "  storage_type = " << typeid(storage_type).name()
-	   << "  delegated_type = " << typeid(delegated_type).name()
+      ostr << "props_of( oln::category::image, " << mlc_to_string(I) << " ) =" << std::endl
+	   << "\t concrete_type = " << mlc_to_string(concrete_type) << std::endl
+	   << "\t value_type = " << mlc_to_string(value_type) << std::endl
+	   << "\t point_type = " << mlc_to_string(point_type) << std::endl
+	   << "\t size_type = " << mlc_to_string(size_type) << std::endl
 
-	   << "  image_constness_type = " << typeid(image_constness_type).name()
-	   << "  image_dimension_type = " << typeid(image_dimension_type).name()
-	   << "  image_neighbness_type = " << typeid(image_neighbness_type).name()
+	   << "\t piter_type = " << mlc_to_string(piter_type) << std::endl
+	   << "\t fwd_piter_type = " << mlc_to_string(fwd_piter_type) << std::endl
+	   << "\t bkd_piter_type = " << mlc_to_string(bkd_piter_type) << std::endl
 
-	   << "  }" << std::endl;
+	   << "\t value_storage_type = " << mlc_to_string(value_storage_type) << std::endl
+	   << "\t storage_type = " << mlc_to_string(storage_type) << std::endl
+	   << "\t delegated_type = " << mlc_to_string(delegated_type) << std::endl
+	   << "\t neighb_type = " << mlc_to_string(neighb_type) << std::endl
+
+	   << "\t image_neighbness_type = " << mlc_to_string(image_neighbness_type)  << std::endl
+	   << "\t image_constness_type = " << mlc_to_string(image_constness_type) << std::endl
+	   << "\t image_dimension_type = " << mlc_to_string(image_dimension_type) << std::endl
+
+	   << std::endl;
     }
 
   };
 
-  mlc_register_prop(category::image, neighb_type);
-  mlc_register_prop(category::image, concrete_type);
-  mlc_register_prop(category::image, value_type);
-  mlc_register_prop(category::image, point_type); 
-  mlc_register_prop(category::image, size_type); 
-  mlc_register_prop(category::image, piter_type); 
-  mlc_register_prop(category::image, fwd_piter_type); 
-  mlc_register_prop(category::image, bkd_piter_type); 
-  mlc_register_prop(category::image, value_storage_type);
-  mlc_register_prop(category::image, storage_type);
-  mlc_register_prop(category::image, delegated_type);
+} // end of namespace oln
 
-  mlc_register_prop(category::image, image_constness_type);
-  mlc_register_prop(category::image, image_dimension_type);
-  mlc_register_prop(category::image, image_neighbness_type);
 
+# include <oln/core/abstract/internal/image_impl.hh>
+# include <oln/core/value_box.hh>
 
 
+namespace oln
+{
 
   /*! \namespace oln::abstract
   ** \brief oln::abstract namespace.
Index: oln/core/abstract/piter.hh
===================================================================
--- oln/core/abstract/piter.hh	(revision 130)
+++ oln/core/abstract/piter.hh	(working copy)
@@ -33,7 +33,7 @@
 # include <mlc/contract.hh>
 
 # include <oln/core/abstract/point.hh>
-# include <oln/core/properties.hh>
+# include <oln/core/typedefs.hh>
 
 
 
@@ -44,55 +44,58 @@
   for(; p.is_valid(); p.next())
 
 
+
+# define oln_pit_type_of(PiterType, Alias) \
+mlc_type_of(oln, oln::category::piter, PiterType, Alias)
+
+
+
 namespace oln {
 
-  // fwd decl
-  namespace abstract {
-    template <typename E> struct piter;
+
+
+  namespace category
+  {
+    struct piter;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::piter<E> > { typedef category::piter ret; };
 
+  template <>
+  struct set_default_props < category::piter >
+  {
+    typedef mlc::undefined_type point_type;
+    typedef mlc::undefined_type size_type;
+  };
 
-  /// properties of any type in category::piter
 
-  template <typename type>
-  struct props_of < category::piter, type >
+  template <typename P>
+  struct get_props < category::piter, P >
   {
-    typedef mlc::true_type user_defined_;
-    
-    mlc_decl_prop(category::piter, size_type);
-    mlc_decl_prop(category::piter, point_type);
+    typedef oln_pit_type_of(P, point) point_type;
+    typedef oln_pit_type_of(P, size)  size_type;
 
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of( category::piter, "
-	   << typeid(type).name() << ") = {"
-	   << "  size_type = " << typeid(size_type).name()
-	   << "  point_type = " << typeid(point_type).name() << "  }" << std::endl;
+      ostr << "props_of( oln::category::piter, " << mlc_to_string(P) << " ) =" << std::endl
+	   << "\t point_type = " << mlc_to_string(point_type) << std::endl
+	   << "\t size_type  = " << mlc_to_string(size_type)  << std::endl
+	   << std::endl;
     }
-
   };
 
-  mlc_register_prop(category::piter, size_type); 
-  mlc_register_prop(category::piter, point_type); 
 
-
-
   namespace abstract {
 
     template <typename E>
-    struct piter : public mlc::any__best_speed<E>
+    struct piter : public mlc::any<E>
     {
 
       /// typedefs
 
       typedef piter<E> self_type;
 
-      typedef oln_type_of(E, size)  size_type;
-      typedef oln_type_of(E, point) point_type;
+      typedef oln_pit_type_of(E, size)  size_type;
+      typedef oln_pit_type_of(E, point) point_type;
 
 
       void start()
Index: oln/core/abstract/image_like_.hh
===================================================================
--- oln/core/abstract/image_like_.hh	(revision 130)
+++ oln/core/abstract/image_like_.hh	(working copy)
@@ -39,25 +39,15 @@
     template <typename I, typename E> struct image_like_;
   }
 
-  // category
-
-  template <typename I, typename E>
-  struct set_category< abstract::image_like_<I, E> > {
-    typedef category::image ret;
-  };
-
   // super type
 
   template <typename I, typename E>
-  struct set_super_type < abstract::image_like_<I, E> >
-  {
-    typedef abstract::image_by_delegation<I, E> ret;
-  };
+  struct set_super_type < abstract::image_like_<I, E> > { typedef abstract::image_by_delegation<I, E> ret; };
 
   // props
 
   template <typename I, typename E>
-  struct set_props < category::image, abstract::image_like_<I, E> > : public props_of<category::image>
+  struct set_props < category::image, abstract::image_like_<I, E> >
   {
     typedef oln_type_of(I, concrete) concrete_type;
   };
Index: oln/core/abstract/point.hh
===================================================================
--- oln/core/abstract/point.hh	(revision 130)
+++ oln/core/abstract/point.hh	(working copy)
@@ -33,7 +33,7 @@
 # include <mlc/cmp.hh>
 
 # include <oln/core/coord.hh>
-# include <oln/core/properties.hh>
+# include <oln/core/typedefs.hh>
 
 
 // fwd decl
@@ -43,47 +43,47 @@
 
 
 
-# define oln_point_type_from_2(P1, P2)   typename mlc::if_< typename mlc::eq< P2, oln::any_point >::ret, P1, P2 >::ret
+# define oln_point_type_from_2(P1, P2)   typename mlc::if_< mlc::eq< P2, oln::any_point >, P1, P2 >::ret
 
 
+# define oln_pt_type_of(PointType, Alias) \
+mlc_type_of(oln, oln::category::point, PointType, Alias)
 
+
+
 /*! \namespace oln
 ** \brief oln namespace.
 */
 namespace oln {
 
 
-  // fwd decl
-  namespace abstract {
-    template <typename E> struct point;
+  namespace category
+  {
+    struct point;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::point<E> > { typedef category::point ret; };
 
+  template <>
+  struct set_default_props < category::point >
+  {
+    typedef mlc::undefined_type dpoint_type;
+  };
 
-  /// properties of any type in category::point
 
-  template <typename type>
-  struct props_of < category::point, type >
+  template <typename P>
+  struct get_props < category::point, P >
   {
-    typedef mlc::true_type user_defined_;
-    
-    mlc_decl_prop(category::point, dpoint_type);
+    typedef oln_pt_type_of(P, dpoint) dpoint_type;
 
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of( category::point, "
-	   << typeid(type).name() << ") = {"
-	   << "  dpoint_type = " << typeid(dpoint_type).name() << "  }" << std::endl;
+      ostr << "props_of( oln::category::point, " << mlc_to_string(P) << " ) =" << std::endl
+	   << "\t dpoint_type = " << mlc_to_string(dpoint_type) << std::endl
+	   << std::endl;
     }
-
   };
 
-  mlc_register_prop(category::point, dpoint_type); 
 
-
   /*! \namespace oln::abstract
   ** \brief oln::abstract namespace.
   */
@@ -97,7 +97,7 @@
     ** Parameter E is the exact type of point.
     */
     template <typename E>
-    struct point : public mlc::any__best_memory<E>
+    struct point : public mlc::any<E>
     {
 
       typedef E exact_type;
@@ -135,7 +135,7 @@
 
       // FIXME: doc...
 
-      typedef oln_type_of(E, dpoint) dpoint_type;
+      typedef oln_pt_type_of(E, dpoint) dpoint_type;
 
       const exact_type operator+(const dpoint_type& dp) const
       {
Index: oln/core/abstract/image_operator.hh
===================================================================
--- oln/core/abstract/image_operator.hh	(revision 130)
+++ oln/core/abstract/image_operator.hh	(working copy)
@@ -39,14 +39,6 @@
     template <typename O, typename I1, typename I2, typename E> struct image_binary_operator;
   }
 
-  // category
-  template <typename O, typename E>
-  struct set_category< abstract::image_operator<O, E> > { typedef category::image ret; };
-  template <typename O, typename I, typename E>
-  struct set_category< abstract::image_unary_operator<O, I, E> > { typedef category::image ret; };
-  template <typename O, typename I1, typename I2, typename E>
-  struct set_category< abstract::image_binary_operator<O, I1, I2, E> > { typedef category::image ret; };
-
   // super types
   template <typename O, typename E>
   struct set_super_type< abstract::image_operator<O, E> > { typedef abstract::image_like_<O, E> ret; };
@@ -56,22 +48,7 @@
   struct set_super_type< abstract::image_binary_operator<O, I1, I2, E> > { typedef abstract::image_operator<O, E> ret; };
 
 
-  // FIXME: an extension of props; remove (test purpose!)
-  template <typename O, typename E>
-  struct set_props < category::image, abstract::image_operator<O, E> > : public props_of<category::image>
-  {
-    typedef float dummy_type;
-  };
-  template <typename O, typename E>
-  struct set_type_of < category::image,
-		       abstract::image_operator<O, E>,
-		       target::dummy_type >
-  {
-    typedef double ret;
-  };
-  // end of FIXME: remove (test purpose!)
 
-
   namespace abstract {
 
 
Index: oln/core/abstract/data_storage.hh
===================================================================
--- oln/core/abstract/data_storage.hh	(revision 130)
+++ oln/core/abstract/data_storage.hh	(working copy)
@@ -29,57 +29,61 @@
 # define OLENA_CORE_ABSTRACT_DATA_STORAGE_HH
 
 # include <mlc/any.hh>
+# include <mlc/to_string.hh>
+# include <oln/core/typedefs.hh>
 
-# include <oln/core/properties.hh>
 
+# define oln_ds_type_of(DataStorageType, Alias) \
+mlc_type_of(oln, oln::category::data_storage, DataStorageType, Alias)
 
+
+
 namespace oln {
 
-  // fwd decl
-  namespace abstract {
-    template <typename E> struct data_storage;
+
+  namespace category
+  {
+    struct data_storage;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::data_storage<E> > { typedef category::data_storage ret; };
 
+  template <>
+  struct set_default_props < category::data_storage >
+  {
+    typedef mlc::undefined_type size_type;
+    typedef mlc::undefined_type point_type;
+    typedef mlc::undefined_type data_type;
+  };
 
-  template <typename type>
-  struct props_of < category::data_storage, type >
+
+  template <typename S>
+  struct get_props < category::data_storage, S >
   {
-    typedef mlc::true_type user_defined_;
+    typedef oln_ds_type_of(S, size)  size_type;
+    typedef oln_ds_type_of(S, point) point_type;
+    typedef oln_ds_type_of(S, data)  data_type;
 
-    mlc_decl_prop(category::data_storage, size_type);
-    mlc_decl_prop(category::data_storage, point_type);
-    mlc_decl_prop(category::data_storage, data_type);
-
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of( category::data_storage, "
-	   << typeid(type).name() << " ) = {"
-	   << "  size_type = " << typeid(size_type).name()
-	   << "  point_type = " << typeid(point_type).name()
-	   << "  data_type = " << typeid(data_type).name() << "  }" << std::endl;
+      ostr << "props_of( oln::category::data_storage, " << mlc_to_string(S) << " ) =" << std::endl
+	   << "\t size_type  = " << mlc_to_string(size_type)  << std::endl
+	   << "\t point_type = " << mlc_to_string(point_type) << std::endl
+	   << "\t data_type  = " << mlc_to_string(data_type)  << std::endl
+	   << std::endl;
     }
-
   };
 
-  mlc_register_prop(category::data_storage, size_type);
-  mlc_register_prop(category::data_storage, point_type);
-  mlc_register_prop(category::data_storage, data_type);
 
-
   namespace abstract {
 
     template <typename E>
-    struct data_storage : public mlc::any__best_speed<E>
+    struct data_storage : public mlc::any<E>
     {
       // typedefs
 
-      typedef oln_type_of(E, size) size_type;
-      typedef oln_type_of(E, point) point_type;
-      typedef oln_type_of(E, data) data_type;
+      typedef oln_ds_type_of(E, size) size_type;
+      typedef oln_ds_type_of(E, point) point_type;
+      typedef oln_ds_type_of(E, data) data_type;
 
       // abstract methods
 
Index: oln/core/abstract/dpoint.hh
===================================================================
--- oln/core/abstract/dpoint.hh	(revision 130)
+++ oln/core/abstract/dpoint.hh	(working copy)
@@ -28,8 +28,9 @@
 #ifndef OLENA_CORE_ABSTRACT_DPOINT_HH
 # define OLENA_CORE_ABSTRACT_DPOINT_HH
 
+# include <mlc/any.hh>
 # include <oln/core/coord.hh>
-# include <mlc/any.hh>
+# include <oln/core/typedefs.hh>
 
 
 /*! \namespace oln
@@ -51,7 +52,7 @@
     ** Parameter E is the exact type of dpoint.
     */
     template <typename E>
-    struct dpoint : public mlc::any__best_memory<E>
+    struct dpoint : public mlc::any<E>
     {
 
       /// Test equality of two dpoints.
Index: oln/core/abstract/regular_niter.hh
===================================================================
--- oln/core/abstract/regular_niter.hh	(revision 130)
+++ oln/core/abstract/regular_niter.hh	(working copy)
@@ -38,7 +38,6 @@
 # include <oln/core/gen/image_with_nbh.hh>
 # include <oln/core/abstract/point.hh>
 # include <oln/core/abstract/dpoint.hh>
-# include <oln/core/properties.hh>
 # include <oln/core/abstract/image.hh>
 # include <oln/core/abstract/neighborhood.hh>
 # include <oln/core/abstract/image_neighbness.hh>
@@ -46,26 +45,14 @@
 
 namespace oln {
 
-  // fwd decls
-
+  // fwd decl
   namespace abstract {
     template <typename E> struct regular_niter;
   }
 
-  // category
-
-  template <typename E>
-  struct set_category< abstract::regular_niter<E> > {
-    typedef category::niter ret;
-  };
-
   // super type
-
   template <typename E>
-  struct set_super_type < abstract::regular_niter<E> >
-  {
-    typedef abstract::niter<E> ret;
-  };
+  struct set_super_type < abstract::regular_niter<E> > { typedef abstract::niter<E> ret; };
 
 
   namespace abstract {
@@ -73,11 +60,8 @@
     template <typename E>
     struct regular_niter : public niter<E>
     {
-
-      /// typedefs
-      typedef oln_type_of(E, point) point_type;
+      typedef oln_type_of(E, point)  point_type;
       typedef oln_type_of(E, dpoint) dpoint_type;
-      typedef regular_niter<E> self_type;
 
       void impl_start()
       {
@@ -86,8 +70,7 @@
 
       void impl_next()
       {
-	precondition(this->is_valid());
-	dp_cur_ ++;
+	++dp_cur_;
       }
 
       void impl_center_at(const point_type& pt)
@@ -104,7 +87,6 @@
 
       const point_type impl_cast_point() const
       {
-	precondition(this->is_valid());
 	return *dp_cur_ + this->p_;
       }
 
@@ -122,17 +104,21 @@
 	  dp_.push_back(this->nbh_[i]);
       }
 
-      template <typename T>
-      regular_niter(const abstract::image_with_nbh<T>& ima) :
-	niter<E>(ima)
+      typedef niter<E> super_type;
+
+      template <typename I>
+      regular_niter(const abstract::image_with_nbh<I>& ima) :
+	super_type(ima)
       {
       }
 
-      typename std::vector<dpoint_type>::iterator dp_cur_;
       std::vector<dpoint_type> dp_;
+      typename std::vector<dpoint_type>::const_iterator dp_cur_;
     };
-  }
-}
 
+  } // end of namespace oln::abstract
 
+} // end of namespace oln
+
+
 #endif // ! OLENA_CORE_ABSTRACT_REGULAR_NITER_HH
Index: oln/core/abstract/image_entry.hh
===================================================================
--- oln/core/abstract/image_entry.hh	(revision 0)
+++ oln/core/abstract/image_entry.hh	(revision 0)
@@ -0,0 +1,70 @@
+// Copyright (C) 2005 EPITA Research and Development Laboratory
+//
+// This file is part of the Olena Library.  This library is free
+// software; you can redistribute it and/or modify it under the terms
+// of the GNU General Public License version 2 as published by the
+// Free Software Foundation.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this library; see the file COPYING.  If not, write to
+// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
+// MA 02111-1307, USA.
+//
+// As a special exception, you may use this file as part of a free
+// software library without restriction.  Specifically, if other files
+// instantiate templates or use macros or inline functions from this
+// file, or you compile this file and link it with other files to
+// produce an executable, this file does not by itself cause the
+// resulting executable to be covered by the GNU General Public
+// License.  This exception does not however invalidate any other
+// reasons why the executable file might be covered by the GNU General
+// Public License.
+
+#ifndef OLENA_CORE_ABSTRACT_IMAGE_ENTRY_HH
+# define OLENA_CORE_ABSTRACT_IMAGE_ENTRY_HH
+
+# include <oln/core/abstract/images.hh>
+
+
+
+
+namespace oln {
+
+  // fwd decl
+  namespace abstract {
+    template <typename E> struct image_entry;
+  }
+
+  // entry => no super type but a category
+
+  template <typename E>
+  struct set_category < abstract::image_entry<E> > { typedef category::image ret; };
+
+
+  namespace abstract {
+
+    template <typename E>
+    struct image_entry :
+      // intrusive:
+      public oln_type_of_(E, image_constness) ::template instantiated_with<E>::ret,
+      public oln_type_of_(E, image_dimension) ::template instantiated_with<E>::ret,
+      public oln_type_of_(E, image_neighbness) ::template instantiated_with<E>::ret,
+      // ...
+      public typeness::inheritance_switch<E>,
+      public valuedness::inheritance_switch<E>
+    {
+    protected:
+      image_entry() {}
+    };
+
+  }
+
+} // end of namespace oln
+
+
+#endif // ! OLENA_CORE_ABSTRACT_IMAGE_ENTRY_HH
Index: oln/core/abstract/images.hh
===================================================================
--- oln/core/abstract/images.hh	(revision 130)
+++ oln/core/abstract/images.hh	(working copy)
@@ -40,7 +40,7 @@
 
 
 // hierarchy entry
-# include <oln/core/abstract/entry.hh>
+# include <oln/core/abstract/image_entry.hh>
 
 
 
Index: oln/core/abstract/image_with_data.hh
===================================================================
--- oln/core/abstract/image_with_data.hh	(revision 130)
+++ oln/core/abstract/image_with_data.hh	(working copy)
@@ -30,7 +30,7 @@
 
 
 # include <mlc/tracked_ptr.hh>
-# include <oln/core/abstract/entry.hh>
+# include <oln/core/abstract/image_entry.hh>
 
 
 /*! \namespace oln
@@ -44,23 +44,13 @@
     template <typename E> class image_with_data;
   }
 
-  // category
-  template <typename E>
-  struct set_category < abstract::image_with_data<E> >
-  {
-    typedef category::image ret;
-  };
-
   // super_type
   template <typename E>
-  struct set_super_type < abstract::image_with_data<E> >
-  {
-    typedef abstract::image_entry<E> ret;
-  };
+  struct set_super_type < abstract::image_with_data<E> > { typedef abstract::image_entry<E> ret; };
 
   // props
   template <typename E>
-  struct set_props < category::image, abstract::image_with_data<E> > : public props_of<category::image>
+  struct set_props < category::image, abstract::image_with_data<E> >
   {
     // intrusive property:
     typedef is_a<abstract::readwrite_image> image_constness_type;
